// Anderson Ferminiano
// 25th June 2011
// contato@andersonferminiano.com -- feel free to contact me for help :)
// www.andersonferminiano.com



var initId = 0;
var player = function(){
	this.object = null;
	this.canJump = false;
};
var world = createWorld();
var ctx;
var canvasWidth;
var canvasHeight;
var canvasTop;
var canvasLeft;
var keys = [];


function step() {
	
	if (player.object.GetCenterPosition().y > canvasHeight){
		player.object.SetCenterPosition(new b2Vec2(20,0),0)
	}	
	else if (player.object.GetCenterPosition().x > canvasWidth-50){
		showWin();
		return;	
	}
	
	
	
	handleInteractions();
	
	var stepping = false;
	var timeStep = 1.0/60;
	var iteration = 1;
	world.Step(timeStep, iteration);
	ctx.clearRect(0, 0, canvasWidth, canvasHeight);
	drawWorld(world, ctx);
	setTimeout('step()', 10);
}

function showWin(){
	ctx.fillStyle    = '#600';
	ctx.font         = '50px helvetica';
	ctx.textBaseline = 'top';
	ctx.fillText('Yes! You made it!', 30, 0);
}

function handleInteractions(){
	// up arrow
	
	var collision = world.m_contactList;
	player.canJump = false;
	if (collision != null){
		if (collision.GetShape1().GetUserData() == 'player' || collision.GetShape2().GetUserData() == 'player'){
			if ((collision.GetShape1().GetUserData() == 'ground' || collision.GetShape2().GetUserData() == 'ground')){
				var playerObj = (collision.GetShape1().GetUserData() == 'player' ? collision.GetShape1().GetPosition() :  collision.GetShape2().GetPosition());
				var groundObj = (collision.GetShape1().GetUserData() == 'ground' ? collision.GetShape1().GetPosition() :  collision.GetShape2().GetPosition());
				if (playerObj.y < groundObj.y){
					player.canJump = true;
				}
			}
		}
	}
	
	var vel = player.object.GetLinearVelocity();
	if (keys[38] && player.canJump){
		vel.y = -200;	
	}
	
	// left/right arrows
	if (keys[37]){
		vel.x = -100;
	}
	else if (keys[39]){
		vel.x = 100;
	}
	
	
	player.object.SetLinearVelocity(vel);
}


function initGame(){
	
	// platforms	
	createBox(world, 0, 250, 60, 180, true, 'ground');
	createBox(world, 350, 90, 200, 20, true, 'ground');
	createBox(world, 650, 50, 20, 200, true, 'ground');
	createBox(world, 400, 250, 150, 20, true, 'ground');
	createBox(world, 600, 200, 5, 5, true, 'ground');
	createBox(world, 180, 300, 10, 30, true, 'ground');
	createBox(world, 100, 380, 10, 30, true, 'ground');
	createBox(world, 250, 430, 10, 30, true, 'ground');
	createBox(world, 400, 400, 80, 10, true, 'ground');
	createBox(world, 530, 420, 20, 10, true, 'ground');
	createBox(world, 600, 500, 20, 10, true, 'ground');
	createBox(world, 900, 700, 200, 200, true, 'ground');
	createBox(world, 1000, 400, 10, 1000, true, 'ground');

	//movable objects
	createBox(world, 120, 10, 70, 3, false, 'ground');
	createBox(world, 270, 10, 10, 30, false, 'ground');
	createBox(world, 310, 10, 10, 30, false, 'ground');
	createBox(world, 350, 10, 10, 30, false, 'ground');
	createBox(world, 550, 130, 70, 3, false, 'ground');
	createBox(world, 600, 330, 150, 3, false, 'ground');
	createBall(world, 800, 0);
	createBall(world, 800, 50);
	createBall(world, 800, 100);
	
	// player ball
	var ballSd = new b2CircleDef();
	ballSd.density = 0.5;
	ballSd.radius = 12;
	ballSd.restitution = 0.6;
	ballSd.friction = 10;
	ballSd.userData = 'player';
	var ballBd = new b2BodyDef();
	ballBd.linearDamping = .03;
	ballBd.allowSleep = false;
	ballBd.AddShape(ballSd);
	ballBd.position.Set(20,0);
	player.object = world.CreateBody(ballBd);
	
}

function handleKeyDown(evt){
	keys[evt.keyCode] = true;
}


function handleKeyUp(evt){
	keys[evt.keyCode] = false;
}

Event.observe(window, 'load', function() {
	world = createWorld();
	ctx = $('game').getContext('2d');
	var canvasElm = $('game');
	canvasWidth = parseInt(canvasElm.width);
	canvasHeight = parseInt(canvasElm.height);
	canvasTop = parseInt(canvasElm.style.top);
	canvasLeft = parseInt(canvasElm.style.left);
	initGame();
	step();
	
	window.addEventListener('keydown',handleKeyDown,true);
	window.addEventListener('keyup',handleKeyUp,true);
});


// disable vertical scrolling from arrows :)
document.onkeydown=function(){return event.keyCode!=38 && event.keyCode!=40}

function resizeGame() {
    var gameArea = document.getElementById('center');
    var widthToHeight = 4 / 3;
    var newWidth = window.innerWidth;
    var newHeight = window.innerHeight;
    var newWidthToHeight = newWidth / newHeight;
    
    if (newWidthToHeight > widthToHeight) {
        newWidth = newHeight * widthToHeight;
        gameArea.style.height = newHeight + 'px';
        gameArea.style.width = newWidth + 'px';
    } else {
        newHeight = newWidth / widthToHeight;
        gameArea.style.width = newWidth + 'px';
        gameArea.style.height = newHeight + 'px';
    }
    
    gameArea.style.marginTop = (-newHeight / 2) + 'px';
    gameArea.style.marginLeft = (-newWidth / 2) + 'px';
    
    var gameCanvas = document.getElementById('game');
    gameCanvas.width = newWidth;
    gameCanvas.height = newHeight;
}

window.addEventListener('resize', resizeGame, false);
window.addEventListener('orientationchange', resizeGame, false);